/* filter.h -- Copyright 1989 Liam R. Quin.  All Rights Reserved.
 * This code is NOT in the public domain.
 * See the file COPYRIGHT for full details.
 */

/* filter.h -- define filter table for NX-Text, Liam Quin's text retrieval
 * program.
 * This table is built from a file like a simplified /etc/magic, normally
 * stored in /usr/local/lib/nx-text/lib/filtertable
 * but you can set this either here or in the Makefile.
 *
 * NEEDS: stdio.h
 *
 * $Id: filter.h,v 1.11 93/04/23 21:04:10 lee Exp $
 *
 */

#define FTYPE_NEWS  1
#define FTYPE_MAIL  2
#define FTYPE_CDMS  3
#define FTYPE_MOSTLYASCII 4
#define FTYPE_DEFAULT 5
#define FTYPE_C_SOURCE 6
#define FTYPE_SGML 7

/* If you add more, you MUST update MaxFilterType at the end of this file;
 * ALWAYS ADD AT THE END or you will break existing databases!
 */


/* The Type field in each array entry is so that I can do some very simple
 * checking...
 */
extern int fclose(), pclose();
struct s_FilterTable {
    int Type;
    int (* close)(); /* how to close the darned stream */
    char *String;
};
    /* If you add more, you MUST update MaxFilterType at the end of this file;
     * ALWAYS ADD AT THE END or you will break existing databases!
     */

#ifndef FILTERDEF
extern struct s_FilterTable FilterTable[];
#else
struct s_FilterTable FilterTable[] = {
    { 0, fclose, 0 }, /* use fopen() */
#ifndef NEWSFILTER
# define NEWSFILTER "/usr/local/lib/lqtext/NewsFilter \"%s\""
#endif
    { FTYPE_NEWS, pclose, NEWSFILTER },
#ifndef MAILFILTER
# define MAILFILTER "/usr/local/lib/lqtext/MailFilter \"%s\""
#endif
    { FTYPE_MAIL, pclose, MAILFILTER },
#ifdef FTYPE_CDMS /* CrystalWriter from Syntactics... */
    { FTYPE_CDMS, pclose, "CDMSFilter -input %s" },
#endif

#ifdef FTYPE_MOSTLYASCII
    { FTYPE_MOSTLYASCII, pclose, "AsciiFilter \"%s\"" },
#endif

#ifdef FTYPE_DEFAULT
# ifndef DEFAULTFILTER
#  define DEFAULTFILTER "/usr/local/lib/lqtext/DefaultFilter \"%s\""
# endif
    { FTYPE_DEFAULT, pclose, DEFAULTFILTER },
#endif

#ifdef FTYPE_C_SOURCE
    { FTYPE_C_SOURCE, pclose, "CFilter \"%s\"" }, /* leave me last! */
#endif
#ifdef FTYPE_SGML

# ifndef SGMLFILTER
#  define SGMLFILTER "/usr/local/lib/lqtext/SGMLFilter \"%s\""
# endif
    { FTYPE_SGML, pclose, SGMLFILTER },
#endif
    /* If you add more, you MUST update MaxFilterType;
     * ALWAYS ADD AT THE END or you will break existing databases!
     */
    { 0, 0, 0 }
};
#endif
#define MaxFilterType FTYPE_SGML
